﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;
using Telerik.Windows;
using System.Windows.Browser;
using Telerik.Windows.Controls.DragDrop;
using System.Collections;
using Telerik.Windows.Controls.TreeView;

namespace _289938_TreeViewContainerBindings
{
	public partial class MainPage : UserControl
	{
		public int Count { get; set; }

		public MainPage()
		{
			InitializeComponent();
			this.treeView.ItemsSource = this.GenerateData();

			Count = 0;

			this.treeView.AddHandler(RadDragAndDropManager.DragInfoEvent, new EventHandler<DragDropEventArgs>(OnDragInfo));
			//this.treeView.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo));
		}

		private void OnDragInfo(object sender, DragDropEventArgs e)
		{
			if (e.Options.Status == DragStatus.DragInProgress)
			{

				ContentControl dragCue = new ContentControl();
				dragCue.ContentTemplate = Resources["DragCueTemplate"] as DataTemplate;
				var payload = (e.Options.Payload as IList)[0];
				dragCue.Content = payload;
				e.Options.DragCue = dragCue;
			}
		}

		private ObservableCollection<Department> GenerateData()
		{
			ObservableCollection<Department> result = new ObservableCollection<Department>();

			for (int j = 0; j < 4; j++)
			{
				Department d = new Department()
				{
					Name = String.Format("Department {0}", j),
					IsExpanded = ((j % 2) == 0)
				};

				for (int k = 0; k < 7; k++)
				{
					Employee e = new Employee()
					{
						Name = String.Format("Employee {0}", k),
						IsExpanded = ((k % 2) == 0)
					};
					d.Employees.Add(e);
				}
				result.Add(d);
			}
			return result;
		}

		private void treeView_Selected(object sender, RadRoutedEventArgs e)
		{

		}

		private void treeView_DragStarted(object sender, RadTreeViewDragEventArgs e)
		{
			int count = this.treeView.SelectedItems.Count;
			foreach (var item in e.DraggedItems)
			{
				if (item is Department)
					(item as Department).Count = count;
				else
					(item as Employee).Count = count;
			}
		}
		
	}
}
